//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//=======================================================================
//@V@:Note: This file generated by vgen V1.07 (00:31:08 21 Nov 1999).
//	SCapp.cpp:	Source for SCApp class
//=======================================================================

#include "SCapp.h"		// Header file

//=========================>>> SCApp::SCApp <<<==========================
  SCApp::SCApp(char* name, int sdi, int h, int w) : vApp(name, sdi, h, w)
  {
    // Constructor

   _SCCmdWin = 0;
  }

//=========================>>> SCApp::SCApp <<<==========================
  SCApp::~SCApp()
  {
    // Destructor
  }

//=====================>>> SCApp::NewAppWin <<<==========================
  vWindow* SCApp::NewAppWin(vWindow* win, char* name,
    int w, int h, vAppWinInfo* winInfo)
  {
    vAppWinInfo* awinfo = winInfo;
    char *appname = name;

    if (!*name)
      {
	 appname = "SC";		// Default name//"T1";
      }
	
    UserDebug1(Build,"SCApp::NewAppWin(%s)\n",appname);

    // Create the first window using provided CmdWindow

    _SCCmdWin = (SCCmdWindow*) win;
    if (!_SCCmdWin)
      {
	_SCCmdWin = new SCCmdWindow(appname, w, h);
      }

    if (!awinfo)
	awinfo = new vAppWinInfo(appname);

    return vApp::NewAppWin(_SCCmdWin, appname, w, h, awinfo);
  }

//============================>>> SCApp::Exit <<<===========================
  void SCApp::Exit(void)
  {
    // This is called to close all windows.

    UserDebug(Build,"SCApp::Exit()\n");

    vApp::Exit();		// Default behavior
  }

//======================>>> SCApp::CloseAppWin <<<===========================
  int SCApp::CloseAppWin(vWindow* win)
  {
    // This will be called BEFORE a window has been unregistered or
    // closed.  Default behavior: unregister and close the window.

    UserDebug(Build,"SCApp::CloseAppWin()\n");

    return vApp::CloseAppWin(win);
  }

//=====================>>> SCApp::AppCommand <<<==============================
  void SCApp::AppCommand(vWindow* win, ItemVal id, ItemVal val, CmdType cType)
  {
    // Commands not processed by the window will be passed here

    UserDebug1(Build,"SCApp::AppCmd(ID: %d)\n",id);
    vApp::AppCommand(win, id, val, cType);
  }

//=========================>>> SCApp::KeyIn <<<==============================
  void SCApp::KeyIn(vWindow* win, vKey key, unsigned int shift)
  {
    // Key strokes not processed by the window will be passed here

    vApp::KeyIn(win, key, shift);
  }

//###########################################################################

  static SCApp SC_App("StarCat",1);	// The instance of the app

//============================>>> AppMain <<<==============================
  int AppMain(int argc, char** argv)
  {
    // Use AppMain to create the main window

	#ifdef WIN32
    (void) theApp->NewAppWin(0, "None", 600, 500);
	#endif

	//make linux slightly larger
	//so toolbar doesn't wrap
	#ifdef LINUX
    (void) theApp->NewAppWin(0, "None", 650, 500);
	#endif

    return 0;
  }
