//StarCatV, Star Catalog Visualization Tool
// (C) 1999  Jim Campbell   jc@izzy.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU  General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//                                                                
// This software is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details. 
//                                      
// You should have received a copy of the GNU General Public License 
// along with this software (see COPYING); if not, write to the 
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//=======================================================================
//@V@:Note: This file generated by vgen V1.07 (00:31:08 21 Nov 1999).
//	SCcnv.cpp:	Source for SCCanvasPane class
//=======================================================================

#include "SCcnv.h"

#include <v/vwindow.h>//for mess handling

//===================>>> SCCanvasPane::SCCanvasPane <<<====================
  SCCanvasPane::SCCanvasPane(vBaseWindow* bw)
  {
	  MRBStatus = 0;//mruber cband stat

	int xsize,ysize;

	//could not get these to work?????
	//xsize = theApp->ScreenWidth();
	//ysize = theApp->ScreenHeight();
	xsize = 1600;
	ysize = 1200;

	//mouse move counter
	MoveCounter = 0;

	memDC = new vMemoryDC(xsize, ysize);
	vColor blk(100, 100 , 100);   // Red
	memDC->SetBackground(blk);
	memDC->Clear();

	//PlotDC = GetDC();

	pWin = (vWindow*) bw;

  }

//===================>>> SCCanvasPane::~SCCanvasPane <<<====================
  SCCanvasPane::~SCCanvasPane()
  {
  }	

//======================>>> SCCanvasPane::HPage <<<========================
  void SCCanvasPane::HPage(int shown, int top)
  {
    vCanvasPane::HPage(shown, top);
  }

//======================>>> SCCanvasPane::VPage <<<========================
  void SCCanvasPane::VPage(int shown, int top)
  {
    vCanvasPane::VPage(shown, top);
  }

//=======================>>> SCCanvasPane::HScroll <<<======================
  void SCCanvasPane::HScroll(int step)
  {
    vCanvasPane::HScroll(step);
  }

//======================>>> SCCanvasPane::VScroll <<<======================
  void SCCanvasPane::VScroll(int step)
  {
    vCanvasPane::VScroll(step);
  }

//======================>>> SCCanvasPane::MouseDown <<<======================
  void SCCanvasPane::MouseDown(int X, int Y, int button)
  {
    vCanvasPane::MouseDown(X,Y,button);

		MDownx = X;
		MDowny = Y;
		MUpx = 0;
		MUpy = 0;
		MFlagD = button;
		SMDown = FramePos(MDownx,MDowny);
  }

//========================>>> SCCanvasPane::MouseUp <<<======================
//
  //On X based systems, 1 is the left button,
  //2 is the middle button, and 3 is the right 
  //button. On Windows, 1 is the left button, and 3 
  //is the right button
  void SCCanvasPane::MouseUp(int X, int Y, int button)
  {
	  float Rad;
    vCanvasPane::MouseUp(X,Y,button);

		MUpx = X;
		MUpy = Y;
		MFlagU = button;
		SMUp = FramePos(MUpx,MUpy);

		//chk for and remove ruber circle
		if(MRBStatus == 1)
		{
			MRBStatus = 0;
			DrawRubberEllipse(LastRLx, LastRLy, LastRLhw, LastRLhw);
		}

		Rad = (float)sqrt(pow(MDownx-MUpx,2) + pow(MDowny-MUpy,2));

		if(Rad == 0)
		{
			if(MFlagU == 1)//right button
				VFMessActType = 1;   //action type:center view
			else
			if(MFlagU == 3)//left button
				VFMessActType = 3;   //action type:id star
			else
				VFMessActType = 0;   //action type:none
		}
		else if(Rad > 20)
		{
			VFMessActType = 2;   //action type:center view
		}
		else//redundant:
		{
			VFMessActType = 0;   //action type:none
		}

		//send mess to cmd wn
		pWin->WindowCommand(101, 1, C_Button);
  }

  //jc added manually:
//======================>>> SCCanvasPane::MouseMotion <<<======================
  void SCCanvasPane::MouseMotion(int x, int y)
  {
		int RLx,RLy,RLhw;
		float Rad;
		vCanvasPane::MouseMotion(x,y);

		//set Mouse x y paos
		Mx = x;
		My = y;

		//figure RA dec positon
		SMPos = FramePos(x,y);

		//mouse move response
		MoveCounter += 1;
		VFMessActType = 10;//

		//this line stops time lapse?
		pWin->WindowCommand(101, 1, C_Button);
  }

//======================>>> SCCanvasPane::MouseMove <<<======================
  void SCCanvasPane::MouseMove(int x, int y, int button)
  {
		int RLx,RLy,RLhw;
		float Rad;
		vCanvasPane::MouseMove(x,y,button);

		Rad = (float)sqrt( pow((float)(MDownx-x),2.0) 
			             + pow((float)(MDowny-y),2.0) );
		RLx = (int)(MDownx - (int)Rad);
		RLy = (int)(MDowny - (int)Rad);
		RLhw = (int)(2 * Rad);

		

		//todo:add first circle test here
		if(MRBStatus == 1)
		DrawRubberEllipse(LastRLx, LastRLy, LastRLhw, LastRLhw);
		
		if(Rad > 10)//then draw rubber circle
		{
			MRBStatus = 1;
			DrawRubberEllipse(RLx, RLy, RLhw, RLhw);
			LastRLx = RLx;
			LastRLy = RLy;
			LastRLhw = RLhw;
		}


  }

//=========================>>> SCCanvasPane::Redraw <<<======================
  void SCCanvasPane::Redraw(int x, int y, int w, int h)
  {
    vCanvasPane::Redraw(x,y,w,h);

	//to handle window redraws and prevent
	//a mess on initial:
	if(drawn)
	{
		CopyFromMemoryDC(memDC, 
			0, 0, 
			0, 0, 
			0, 0);
	}

	//for Lesstif initialization
    if(!drawn)
	{
		SetViewSizeParam(w,h);
		drawn = true;
	}



  }

//======================>>> SCCanvasPane::Resize <<<======================
  void SCCanvasPane::Resize(int w, int h)
  {
    vCanvasPane::Resize(w,h);

	SetViewSizeParam(w,h);

	//To add messages back to main comand win:
	// -Add(vWindow* pWin;) to this.h
	// -Add(SCCanvasPane(vBaseWindow* bw)) to param list of constructor
	// -Add(pWin = (vWindow*) bw;) in constructor
	// -Add(VF = new SCCanvasPane(this);) in comd win constuctor cnv constructor
	// -Move Item ID defines so visable here?
	//   or just cheat and get the id directly...
	//   ->redraws then blanks screen?...
	// pWin->WindowCommand(104, 1, C_Button);
	 
  }

   void SCCanvasPane::Test()
  {
	    
	DrawLine(1,1, 20,20);
	//SetWidthHeight(200, 300);
	DrawLine(20,20, 100,20);
  }

//////////////////////////////////////////////////////////
//SetViewParam
//
//////////////////////////////////////////////////////////
void SCCanvasPane::SetViewParam(float RA, float Dec, float Rot,
							  float Ang,  int ColorM)
{
	ColorMode = ColorM;
	ViewCen.RA = RA;	//in deg
	ViewCen.Dec = Dec;	//in deg
	ViewCen.Mag = 0;


	VCRot = Rot;		//in deg
	VCHAng = Ang / 2;	//in deg
}

//////////////////////////////////////////////////////////
//SetViewSizeParam(int x, int y)
//
//////////////////////////////////////////////////////////
void SCCanvasPane::SetViewSizeParam(int x, int y)
{	
	FXMax = x;
	FYMax = y;				//view frame size
	FXCen = x / 2;
	FYCen = y / 2;				//frame center

	int i;//dd stop
	i=1;
}
//////////////////////////////////////////////////////////
//ClearView
//
//////////////////////////////////////////////////////////
void SCCanvasPane::ClearView()
{
	//set background color depending on ColorMode
	if(ColorMode == 3)
	{
		vColor wht(255, 255 , 255);   // wht
		OutputDC->SetBackground(wht);
		OutputDC->Clear();
	}
	else
	{
		vColor blk(0, 0 , 0);   // Red
		//_cpDC->SetBackground(blk);
		//memDC->SetBackground(blk);
		//memDC->Clear();
		OutputDC->SetBackground(blk);
		OutputDC->Clear();
		//SetBackground(blk);
	}
}

///////////////////////////////////////
//PlotObject
// Object = 0=Sun   1=Mercury
//          2=Venus 3=Earth? 
//          4=Mars  5=Jupiter
//          6=Saturn 7= Uranus
//          8=Neptune 9=Pluto
//          10=Moon
//
//
///////////////////////////////////////////
bool SCCanvasPane::PlotObject(STARDATA Star,
							  int Object,int Color,
							  float Dia,int Label,
							  int *xplot, int *yplot)
{
	bool ret;

	ret = FALSE;

	int x,y,pixDia,ex,ey,r;
	double Dist,Vec;
	//STARDATA RelDist;
	POLARVEC PDist;
	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP;		//frame deg to pixel conv
	char strLabel[20];
	vColor color;

	DtoP  = FYCen / VCHAng;
	//jac// RelDist = DistAngVec(ViewCen,Star);
	PDist = VM.DistVec(ViewCen,Star);

	ret = FALSE;

	Dist = PDist.Rad;
	Vec = PDist.Ang;

	x = (int)(FXCen - DtoP * Dist * sin(DtoR * (Vec + VCRot)));
	y = (int)(FYCen - DtoP * Dist * cos(DtoR * (Vec + VCRot)));
	
	if (x>0 && x<FXMax && y>0 && y<FYMax)
	{
		ret = TRUE;

		pixDia = (int)((Dia / (VCHAng *2)) *FYMax);
		r = pixDia/2;
		ex = x - r;
		ey = y - r;


		switch(Object)
		{	case 0:{strcpy(strLabel,"Sun");
					SetGenPenRGB(255,255,150);//pale yellow;
					if(pixDia<10)
					{
						PutStar(x,y,2,-1,-3);
					}
					else
					{
						OutputDC->DrawEllipse(ex, ey, pixDia, pixDia);
					}
					break;}
			case 1:{strcpy(strLabel,"Mercury");
					SetGenPenRGB(200,0,0);//redish
					PutStar(x,y,2,-1,2);
					break;}
			case 2:{strcpy(strLabel,"Venus");
					SetGenPenRGB(0,0,250);//blueish
					PutStar(x,y,2,-1,1);	
					break;}
			case 3:{;break;}
			case 4:{strcpy(strLabel,"Mars");
					SetGenPenRGB(250,50,50);//reddish
					PutStar(x,y,2,-1,1);
					break;}
			case 5:{strcpy(strLabel,"Jupiter");
					SetGenPenRGB(255,150,0);//yellow
					PutStar(x,y,2,-1,1);
					break;}
			case 6:{strcpy(strLabel,"Saturn");
					SetGenPenRGB(255,200,0);//yellow
					PutStar(x,y,2,-1,1);
					break;}
			case 7:{strcpy(strLabel,"Uranus");
					SetGenPenRGB(0,220,50);//yellow
					PutStar(x,y,2,-1,2);
					break;}
			case 8:{strcpy(strLabel,"Neptune");
					SetGenPenRGB(50,220,0);//yellow
					PutStar(x,y,2,-1,2);
					break;}
			case 9:{strcpy(strLabel,"Pluto");
					SetGenPenRGB(150,150,255);//purple
					PutStar(x,y,2,-1,3);
					break;}
			case 10:{strcpy(strLabel,"Moon");
					SetGenPenRGB(180,180,180);//gray
					if(pixDia<15)
					{
						PutStar(x,y,2,-1,-3);
					}
					else
					{
						OutputDC->DrawEllipse(ex, ey, pixDia, pixDia);
					}
					break;}
				case 11:{strcpy(strLabel,"Moon2");
					SetGenPenRGB(250,180,180);//gray
					if(pixDia<15)
					{
						PutStar(x,y,2,-1,-3);
					}
					else
					{
						OutputDC->DrawEllipse(ex, ey, pixDia, pixDia);
					}
					break;}
		}

		if(Label == 1)
		{
			PlotTextXY(strLabel,x, y ,0,-10,0,4);//small and green
		}

	}

	*xplot = x;
	*yplot = y;

	return(ret);
}
///////////////////////////////////////
//PlotStar Plots Star and label with num
//   if other than 0.
//returns true if star plots in frame
//  inputs:  Style 0 = blip mode
//                 1 = blob mode
//					Color see SetGenPen
//
///////////////////////////////////////////
bool SCCanvasPane::PlotStar(STARDATA Star,int Style,int Color)
{
	bool ret;

	int x,y;
	double Dist,Vec;
	//STARDATA RelDist;
	POLARVEC PDist;
	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP;		//frame deg to pixel conv

	DtoP  = FYCen / VCHAng;
	//jac// RelDist = DistAngVec(ViewCen,Star);
	PDist = VM.DistVec(ViewCen,Star);

	ret = FALSE;

	Dist = PDist.Rad;
	Vec = PDist.Ang;

	x = (int)(FXCen - DtoP * Dist * sin(DtoR * (Vec + VCRot)));
	y = (int)(FYCen - DtoP * Dist * cos(DtoR * (Vec + VCRot)));
	
	if (x>0 && x<FXMax && y>0 && y<FYMax)
	{
		PutStar(x,y,Style,Color,Star.Mag);
		//set last ploted star postion buff
		LastX = x;
		LastY = y;
		ret = TRUE;	
	}

	return(ret);

}


////////////////////////////////////////////////////////
//GetVSPosRect
//Gets actual position in pixels of star ploted in frame
//
//returns in RECTVEC type using only .x and .y
//
//
/////////////////////////////////////////////////////////
RECTVEC SCCanvasPane::GetPSPosFC(STARDATA Star)
{
	RECTVEC FC;

	FC.x = LastX;
	FC.y = LastY;
	FC.z = 0;
	return(FC);
}



///////////////////////////////////////////////
//PutStar(int x, int y,int Style,int Color, float Mag)
//  puts star in x,y position of Sviewframe
//  first test if x,y is in range
//  Style = 0, blip mode
//	        1, tick mode
//	        2, blob mode
//	        3, med blob mode
//	        4, big bloc mode
//	        10, spec id tick mode mode
/////////////////////////////////////////////////
void SCCanvasPane::PutStar(int x, int y,int Style,int Color, float Mag)
{
	if (x>0 && x<FXMax && y>0 && y<FYMax)
	{
		if(Color >= 0)
		{
			SetGenPen(Color);
			//SetPen(pGenPen);
			//SetBrush(pGenBrush);
		}

		float MagRef;
	
		if (Style == 0) //then blip mode
		{
			OutputDC->DrawPoint(x, y);
			//DrawLine(x-1,y, x+1,y);
			//DrawLine(x,y-1, x,y+1);
		}

		else
		if (Style == 1) //then blip mode
		{
			
			OutputDC->DrawLine(x-3,y, x+3,y);
			OutputDC->DrawLine(x,y-3, x,y+3);
		}
	
		else
		if(Style == 2
			||Style ==3
			||Style ==4
			||Style ==5
			||Style ==6
			||Style ==7)//blob modes
		{
			//adjust ref level dep on style
			if(Style == 2)
				MagRef = Mag -2;
			else if(Style == 3)
				MagRef = Mag -3;
			else if(Style == 4)
				MagRef = Mag -4;
			else if(Style == 5)
				MagRef = Mag -5;
			else if(Style == 6)
				MagRef = Mag -6;
			else if(Style == 7)
				MagRef = Mag -7;
			else//redundant
				MagRef = Mag - 2;


			if(MagRef < -4)
			OutputDC->DrawEllipse(x-5, y-5, 11, 11);
			if(MagRef < -3)
			OutputDC->DrawEllipse(x-5, y-5, 10, 10);
			if(MagRef < -2)
			OutputDC->DrawEllipse(x-4, y-4, 9, 9);
			if(MagRef < -1)
			OutputDC->DrawEllipse(x-4, y-4, 8, 8);
			else if(MagRef < 0)
			OutputDC->DrawEllipse(x-3, y-3, 7, 7);
			else if(MagRef < 1)
			OutputDC->DrawEllipse(x-3, y-3, 6, 6);
			else if(MagRef < 2)
			OutputDC->DrawEllipse(x-2, y-2, 5, 5);
			else if(MagRef < 3)
			OutputDC->DrawEllipse(x-2, y-2, 4, 4);
			else if(MagRef < 4)
			{
				//OutputDC->DrawEllipse(x-1, y-1, 3, 3);
				OutputDC->DrawPoint(x, y);
				OutputDC->DrawPoint(x, y+1);
				OutputDC->DrawPoint(x, y-1);
				OutputDC->DrawPoint(x+1, y);
				OutputDC->DrawPoint(x-1, y);
			}
			else if(MagRef < 5)
			{
				OutputDC->DrawPoint(x, y);
			}
			else
			OutputDC->DrawPoint(x, y);
		}

		else
		if(Style == 10)//spec id blip style
		{
			OutputDC->DrawLine(x-7,y, x+7,y);
			OutputDC->DrawLine(x,y-7, x,y+7);
		}
		
	}
}

////////////////////////////////////////////////////
//SetGenPenRGB
//  Sets gen pen to RGB value
//  if ColorMode != 0, uses default colors for all
//   0=norm,1=whtonBlk,2=redonblk,4=black on white
////////////////////////////////////////////////////
void SCCanvasPane::SetGenPenRGB(int R, int G, int B)
{
	vColor color;

	if(ColorMode == 0)
	{
		color.Set(R,G,B);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}
	else
	if(ColorMode == 1)//wht on black
	{
		color.Set(255,255,255);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}
	else
	if(ColorMode == 2)//red on black
	{
		color.Set(255,0,0);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}
	else
	if(ColorMode == 3)//black on wht
	{
		color.Set(0,0,0);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}

	OutputDC->SetPen(pGenPen);
	OutputDC->SetBrush(pGenBrush);
}
////////////////////////////////////////////////////
//PickPen
//Picks a pen and sets it active
// if ColorMode 1= 0, uses default colors for all
//0=norm,1=whtonBlk,2=redonblk,4=black on white
//
//othewise, set to :
//
//0 = white
//1=Red
//2=Blue
//3=LBlue
//4=Grn
//5=LGrn
//6 = yel
//7 = black
// 8 = white
//11=gray
////////////////////////////////////////////////////
void SCCanvasPane::SetGenPen(int penID)
{

	vColor color(255, 255 , 255); 
	pGenPen.SetColor(color);

	if(ColorMode == 0)
	{
		if(penID == 0)//wht
		{
			color.Set(255,255,255);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}

		else if(penID == 1)//red
		{
			color.Set(255,0,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 2)//blue
		{
			color.Set(0,0,255);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 3)//3=LBlue
		{
			color.Set(0,0,180);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 4)//4=Grn
		{
			color.Set(0,255,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 5)//5=LGrn
		{
			color.Set(0,180,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 6)//6 = yel
		{
			color.Set(255,255,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 7)//7 = black
		{
			color.Set(255,255,255);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 8)
		{
			color.Set(255,0,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 9)
		{
			color.Set(255,0,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else if (penID == 11)
		{
			color.Set(150,150,150);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
		else
		{
			color.Set(0,0,0);
			pGenPen.SetColor(color);
			pGenBrush.SetColor(color);
		}
	}
	else
	if(ColorMode == 1)//wht on black
	{
		color.Set(255,255,255);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}
	else
	if(ColorMode == 2)//red on black
	{
		color.Set(255,0,0);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}
	else
	if(ColorMode == 3)//black on wht
	{
		color.Set(0,0,0);
		pGenPen.SetColor(color);
		pGenBrush.SetColor(color);
	}

	OutputDC->SetPen(pGenPen);
	OutputDC->SetBrush(pGenBrush);

}


///////////////////////////////////////////
//Plots text as x,y frame position
//  inputs:  Style	0 = Small
//					1 = large
//           Color	0 = white
//					1 = red
//					2 = Blue
//					3 = LBlue
//					4 = Grn
//					5 = LGrn
//					6 = yel
//					7 = black
//					8 = white
///////////////////////////////////////////
void SCCanvasPane::PlotTextXY(char* text, int x, int y ,
							int xos,int yos,
							int Style,int Color)
{
	int tlen = strlen(text);	

	//set color
	SetGenPen(Color);
	//OutputDC->SetPen(pGenPen);
	//
	//set size
	vFont Font0(vfSansSerif,8,vfNormal,vfNormal,0,0);
	vFont Font1(vfSansSerif,10,vfNormal,vfNormal,0,0);	
	vFont Font2(vfSansSerif,15,vfNormal,vfNormal,0,0);
	
	if(Style == 0)//small
	{
		OutputDC->SetFont(Font0);
		xos = xos - tlen * 3;
		yos = yos;
	}
	else if(Style == 1)//med
	{
		OutputDC->SetFont(Font1);
		xos = xos -tlen * 4;
		yos = yos;
	}
	else if(Style == 2)//giant
	{
		OutputDC->SetFont(Font2);
		xos = xos;
		yos = yos;
	}
	else//small
	{
		OutputDC->SetFont(Font2);
	}

	//output text with offset
	//m_memDC.TextOut(x + xos,y + yos, text,text.GetLength()-1);
	//DrawAttrText(x + xos, y +yox, text,  ChNormal);
	OutputDC->DrawText(x + xos, y +yos, text);

  }


///////////////////////////////////////////
//PlotTextS()
//Plots text as STARDATA frame position
//  inputs:  Style	and Color as PLotTextXY
//					 
////////////////////////////////////////////
void SCCanvasPane::PlotTextS(char* text, STARDATA S1,
						   int xos,int yos,
							int Style,int Color)
{
	int x,y;
	double Dist,Vec;
	//STARDATA RelDist;
	POLARVEC PDist;
	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP;		//frame deg to pixel conv
	DtoP  = FYCen / VCHAng;
	PDist = VM.DistVec(ViewCen,S1);

	Dist = PDist.Rad;
	Vec = PDist.Ang;
	x = (int)(FXCen - DtoP * Dist * sin(DtoR * (Vec + VCRot)));
	y = (int)(FYCen - DtoP * Dist * cos(DtoR * (Vec + VCRot)));

	if (x>0 && x<FXMax && y>0 && y<FYMax)
	{
		PlotTextXY(text,x,y,xos,yos,Style,Color);
	}
	
}



////////////////////////////////////////////////////////////
//PlotSeg
//plots line between Star1 and Star2 in SView frame
//
///////////////////////////////////////////////////////////
void SCCanvasPane::PlotSeg(STARDATA Star1,STARDATA Star2)
{
	
	POLARVEC D1,D2;
	int x1,y1,x2,y2;

	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP  = FYCen / VCHAng;

	//vPen p;
	//vColor wht(0, 0 , 255); 
	//p.SetColor(wht);
	//OutputDC->SetPen(pGenPen);


	D1 = VM.DistVec(ViewCen,Star1);
	D2 = VM.DistVec(ViewCen,Star2);
	//180deg error here
	//error occurs only when Az = 0, exp:when 
	//viewcen.RA = 314.248 and Star1.RA=134.238..
	//glug way to fix:avoid Az = exactly zero.

	if(D1.Rad < (VCHAng * 2) && D2.Rad < (VCHAng * 2))
	{
		x1 = (int)(FXCen - DtoP * D1.Rad * sin(DtoR * (D1.Ang + VCRot)));
		y1 = (int)(FYCen - DtoP * D1.Rad * cos(DtoR * (D1.Ang + VCRot)));
		x2 = (int)(FXCen - DtoP * D2.Rad * sin(DtoR * (D2.Ang + VCRot)));
		y2 = (int)(FYCen - DtoP * D2.Rad * cos(DtoR * (D2.Ang + VCRot)));

		OutputDC->DrawLine(x1,y1, x2,y2);
	//	m_memDC.MoveTo(x1,y1);
	//	m_memDC.LineTo(x2,y2);

		//trap error in alt az grid plot
		//error on 180 deg diff
		if((x1==0 &y1 ==0&y2==0&x2==0)  )
		{
			int dum = 1;
		}
		
		//newpen.DeleteObject();
	}

}



////////////////////////////////////////////////////////////
//PlotSeg
//plots line between Star1 and Star2 in SView frame
//
///////////////////////////////////////////////////////////
void SCCanvasPane::PlotGrid()
{
	float r,d;
	STARDATA S1,S2;
/*
	//select color
	if(ColorMode == 0)
		PickPen(3);//light blue pen
	else if(ColorMode == 1)
		PickPen(7);//black pen
	else if(ColorMode == 2)
		PickPen(8);//white pen
*/
	r = 0;
	while (r < 360)
	{
/*		//select color
		if(ColorMode == 0)
			PickPen(3);//light blue pen
		else if(ColorMode == 1)
			PickPen(7);//black pen
		else if(ColorMode == 2)
			PickPen(8);//white pen
*/
		//do top half
		d = 0;
		while (d < 80)
		{
			S1.RA = r;
			S1.Dec = d;
			S2.RA = r;
			S2.Dec = d + 5;
			PlotSeg(S1,S2);

			S1.RA = r;
			S1.Dec = d + 5;
			S2.RA = r;
			S2.Dec = d + 10;
			PlotSeg(S1,S2);

			S1.RA = r;
			S1.Dec = d;
			S2.RA = r + 5;
			S2.Dec = d;
			PlotSeg(S1,S2);

			S1.RA = r + 5;
			S1.Dec = d;
			S2.RA = r + 10;
			S2.Dec = d;
			PlotSeg(S1,S2);

			S1.RA = r + 10;
			S1.Dec = d;
			S2.RA = r + 15;
			S2.Dec = d;
			PlotSeg(S1,S2);

			d = d + 10;
		}
		
		//do bottom half
		d = 0;
		while (d > - 80)
		{
			S1.RA = r;
			S1.Dec = d;
			S2.RA = r;
			S2.Dec = d - 5;
			PlotSeg(S1,S2);

			S1.RA = r;
			S1.Dec = d - 5;
			S2.RA = r;
			S2.Dec = d - 10;
			PlotSeg(S1,S2);

			S1.RA = r;
			S1.Dec = d;
			S2.RA = r + 5;
			S2.Dec = d;
			PlotSeg(S1,S2);

			S1.RA = r + 5;
			S1.Dec = d;
			S2.RA = r + 10;
			S2.Dec = d;
			PlotSeg(S1,S2);

			S1.RA = r + 10;
			S1.Dec = d;
			S2.RA = r + 15;
			S2.Dec = d;
			PlotSeg(S1,S2);

			d = d - 10;
		}

		//draw equat in dark blue

/*		//select color
		if(ColorMode == 0)
			PickPen(2);//blue pen
		else if(ColorMode == 1)
			PickPen(7);//black pen
		else if(ColorMode == 2)
			PickPen(8);//white pen
*/
		S1.RA = r;
		S1.Dec = 0;
		S2.RA = r + 5;
		S2.Dec = 0;
		PlotSeg(S1,S2);

		S1.RA = r + 5;
		S1.Dec = 0;
		S2.RA = r + 10;
		S2.Dec = 0;
		PlotSeg(S1,S2);

		S1.RA = r + 10;
		S1.Dec = 0;
		S2.RA = r + 15;
		S2.Dec = 0;
		PlotSeg(S1,S2);
		r = r + 15;
	}
}
////////////////////////////////////////////////////////////
//PlotHorizon(STARDATA cZenith)
//plots horizon line
//
///////////////////////////////////////////////////////////
void SCCanvasPane::PlotHorizon(STARDATA cZenith)
{
	STARDATA	S1,S2;
	float HAng;
	//float rindex = 10;
	//float dindex = 10;
	int i;

	//select color
	//if(ColorMode == 0)
	//	PickPen(4);//light blue pen
	//else if(ColorMode == 1)
	//	PickPen(7);//black pen
	//else if(ColorMode == 2)
	//	PickPen(8);//white pen
	SetGenPen(4);

	HAng = 0;
	for (i=0;i < 36;i++)
	{
		S1 = VM.VecRot(cZenith,90,HAng);
		S2 = VM.VecRot(cZenith,90,HAng + 10);
		PlotSeg(S1,S2);
		S2 = VM.VecRot(cZenith,89,HAng);
		PlotSeg(S1,S2);
		HAng += 10;
	}

	//plot zenith
	S1 = VM.VecRot(cZenith,1,0);
	S2 = VM.VecRot(cZenith,1,180);
	PlotSeg(S1,S2);
	S1 = VM.VecRot(cZenith,1,90);
	S2 = VM.VecRot(cZenith,1,270);
	PlotSeg(S1,S2);

}

////////////////////////////////////////////////////////////
//PlotAltAzGrid(STARDATA cZenith)
//
//
///////////////////////////////////////////////////////////
void SCCanvasPane::PlotAltAzGrid(STARDATA cZenith)
{
	STARDATA	S1,S2;
	float r,d;
	float rindex = 10;
	float dindex = 10;

	//select color
	//if(ColorMode == 0)
	//	PickPen(5);//light blue pen
	//else if(ColorMode == 1)
	//	PickPen(7);//black pen
	//else if(ColorMode == 2)
	//	PickPen(8);//white pen
	SetGenPen(5);

	d = 10;
	while(d < 90)
	{
		r = 0;
		while(r < 360)
		{
			S1 = VM.VecRot(cZenith,d,r);
			S2 = VM.VecRot(cZenith,d,r + 2);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d,r + 2);
			S2 = VM.VecRot(cZenith,d,r + 4);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d,r + 4);
			S2 = VM.VecRot(cZenith,d,r + 6);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d,r + 6);
			S2 = VM.VecRot(cZenith,d,r + 8);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d,r + 8);
			S2 = VM.VecRot(cZenith,d,r + 10);
			PlotSeg(S1,S2);

			S1 = VM.VecRot(cZenith,d,r);
			S2 = VM.VecRot(cZenith,d+2,r);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d+2,r);
			S2 = VM.VecRot(cZenith,d+4,r);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d+4,r);
			S2 = VM.VecRot(cZenith,d+6,r);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d+6,r);
			S2 = VM.VecRot(cZenith,d+8,r);
			PlotSeg(S1,S2);
			S1 = VM.VecRot(cZenith,d+8,r);
			S2 = VM.VecRot(cZenith,d+10,r);
			PlotSeg(S1,S2);
			
			r += 10;
		}
		d += 10;
	}
}

////////////////////////////////////////////////////////////
//PlotHorizonCompLabels(STARDATA cZenith)
//
//
///////////////////////////////////////////////////////////
void SCCanvasPane::PlotHorizonCompLabels(STARDATA cZenith)
{
	STARDATA	S1;
	int x,y,i;
	float HAng;
	char text[6];


	vFont Font1(vfSansSerif,15,vfNormal,vfNormal,0,0);
	OutputDC->SetFont(Font1);

	//plot nsew markers
	S1 = VM.VecRot(cZenith,89.0,0);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "N");
		OutputDC->DrawAttrText(x-8, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,45);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "NE");
		OutputDC->DrawAttrText(x-16, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,90);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "E");
		OutputDC->DrawAttrText(x-8, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,135);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "SE");
		OutputDC->DrawAttrText(x-16, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,180);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "S");
		OutputDC->DrawAttrText(x-8, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,225);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "SW");
		OutputDC->DrawAttrText(x-16, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,270);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "W");
		OutputDC->DrawAttrText(x-8, y, text,  ChNormal);
	}

	S1 = VM.VecRot(cZenith,89.0,315);
	if(FrameRectPos(S1,x,y) == 1)
	{
		sprintf( text, "NW");
		OutputDC->DrawAttrText(x-16, y, text,  ChNormal);
	}

	//plot headings
	//m_memDC.SelectObject(&FontA);
	vFont Font2(vfSansSerif,8,vfNormal,vfNormal,0,0);
	OutputDC->SetFont(Font2);
	HAng = 0;
	for (i=0;i < 36;i++)
	{
		S1 = VM.VecRot(cZenith,90,HAng);
		
		if(FrameRectPos(S1,x,y) == 1)
			{
				sprintf( text, "%3d",(int)HAng);
				OutputDC->DrawAttrText(x-5, y+16, text,  ChNormal);
			}
		HAng += 10;
	}

}





/////////////////////////////////////////////////////
//PlotLegend()
//
//Uses SynRefLev
//
//
/////////////////////////////////////////////////////
void SCCanvasPane::PlotLegend(int Style, int MaxMag)
{
	
	int x,y,yt;
	int xorg = 15;
	int yorg = 15;
	int xoffset = 15;
	int ytextos = 25;
	float AbsMag;
	float Mag;

	char text[6];
	
	SetGenPen(0);

	x = xorg;
	y = yorg;
	yt = yorg + ytextos;
	Mag = -1;

	while (Mag <= MaxMag)
	{
		AbsMag = Mag;// + (int)SymRefLev;
		sprintf( text, "%2d", (int)Mag);

		PlotTextXY(text, x, yt ,
					0,0,
					0,0);

		PutStar(x,y,Style,0,Mag/*Mag + SymRefLev*/);

		Mag += 1;
		x = x + xoffset;
	}

}

////////////////////////////////////////////
//PlotViewCenter(float Rad)
//if Rad = 0, plots tick, if not, plots circle
//of rad.
void SCCanvasPane::PlotViewCenter(float Rad)
{
	
	float a,PRad;
	int x1,y1,x2,y2;
	//STARDATA S1,S2;

	double DtoR = ( 2 * 3.14159265) / 360;

	double DtoP;		//frame deg to pixel conv
	DtoP  = FYCen / VCHAng;
	PRad = Rad * (float)DtoP;


	//select color
	//if(ColorMode == 0)
	//	PickPen(9);//light red pen
	//else if(ColorMode == 1)
	//	PickPen(7);//black pen
	//else if(ColorMode == 2)
	//	PickPen(8);//white pen
	SetGenPen(1);
	//OutputDC->SetPen(pGenPen);

	if (Rad == 0)
	{
		//DrawLine(x1,y1, x2,y2);
		OutputDC->DrawLine(FXCen - 2,FYCen,
						 FXCen + 2,FYCen);
		OutputDC->DrawLine(FXCen,FYCen - 2,
						 FXCen,FYCen + 2);	
	}
	else
	{
		a = 0;
		while (a < 360)
		{	
			x1 = FXCen + (int)(PRad * sin(a*DtoR));
			y1 = FYCen + (int)(PRad * cos(a*DtoR));
			a = a + 10;
			x2 = FXCen + (int)(PRad * sin(a*DtoR));
			y2 = FYCen + (int)(PRad * cos(a*DtoR));

			OutputDC->DrawLine(x1,y1,x2,y2);					
		}


	}


}






//////////////////////////////////////////////////
//FrameRectPos()
//  inputs STARDATA
//  returns 1 if within window, 0 if not
//////////////////////////////////////////////////
int SCCanvasPane::FrameRectPos(STARDATA SPos, int &x, int &y)
{
	int ret;

	double Dist,Vec;
	POLARVEC PDist;
	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP;		//frame deg to pixel conv
	DtoP  = FYCen / VCHAng;
	PDist = VM.DistVec(ViewCen,SPos);

	Dist = PDist.Rad;
	Vec = PDist.Ang;
	x = (int)(FXCen - DtoP * Dist * sin(DtoR * (Vec + VCRot)));
	y = (int)(FYCen - DtoP * Dist * cos(DtoR * (Vec + VCRot)));

	if (x>0 && x<FXMax && y>0 && y<FYMax)
		ret = 1;
	else
		ret = 0;

	return(ret);
}

//////////////////////////////////////////////////////////
//FramePos(int xin, int yin)
//  Inputs x,y coords of view frame and output the celest
//  coords of the point as STARDATA.
//	Uses class globals:FXCen,FYCen,VCHAng,VCRot
//
//////////////////////////////////////////////////////////
STARDATA SCCanvasPane::FramePos(int xin, int yin)
{
	int x,y,dx,dy;
	float Dist, DistD,Ang,AngB;
	STARDATA S1;

	double DtoR = ( 2 * 3.14159265) / 360;
	double RtoD = 1 / DtoR;
	double DtoP;		//frame deg to pixel conv
	DtoP  = FYCen / VCHAng;

	x = xin;
	y = yin;

	dx = x - FXCen;
	dy = y - FYCen;
	Dist = (float)sqrt(dx*dx + dy*dy);
	DistD = (float)(1/DtoP) * Dist;

	if(dx == 0)
		{
			if (dy < 0)
					Ang = 0;
			else
					Ang = 180;	
		}
	else if(dx > 0)
		{
			AngB = (float)RtoD * (float)acos(dy/Dist);
			Ang = 180 + AngB;
		}
	else if (dx < 0)
		{	
			Ang = 180 - (float)RtoD * (float)acos(dy/Dist) ;
		}

	//add view rotation into mix
	Ang = Ang - VCRot;
	if (Ang <=360) Ang = Ang + 360;

	//find RA Dec of clicked x,y
	S1 = VM.VecRot(ViewCen,DistD,Ang);

	return(S1);
}

//////////////////////////////////////////////////////////
//SelectPlotDC
// Select DC, 0 = Windowcanvas
//            1 = memDC
//            2 = printer
//////////////////////////////////////////////////////////
void SCCanvasPane::SelectPlotDC(int SelDC)
{
	if(SelDC == 0)
	{
		OutputDC =(vDC*)_cpDC;
		//OutputDC = GetDC();
		//PlotDC = memDC;
	}
	else
	if(SelDC == 1)
	{
		OutputDC =(vDC*) memDC;
	}
	else
	if(SelDC == 2)
	{
		OutputDC=(vDC*) &pdc;
	}
}

//////////////////////////////////////////////////////////
//UpdateCanvasDC
//  Copies memDC to app canvas.
//////////////////////////////////////////////////////////
void SCCanvasPane::UpdateCanvasDC()
{
	 CopyFromMemoryDC(memDC, 
		 0, 0, 
		 0, 0, 
		 0, 0);
}

//////////////////////////////////////////////////////////
//SetupToPrint()
//  Returns 1 if successfull, 0 otherwise
//////////////////////////////////////////////////////////
int SCCanvasPane::SetupToPrint()
{
	int ret,i;
    if(printer.Setup("test.ps") != 1 )   // setup the 
		return(0);
	//ret = printer.Setup("test.ps");
	//i= ret;

	//if(ret != 1) return(0);

    pdc.SetPrinter(printer);    // change to the printer we setup

    if (!pdc.BeginPrinting())   // call BeginPrinting first
        return(0);

    //pdc.SetTranslate(36,36);    // Add 1/2" (36 * 1/72") margins

    //DrawShapes(&pdc);           // Now, call shared drawing method
	//SelectPlotDC(2);
	return(1);
}

//////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////
void SCCanvasPane::EndPrint()
{
	pdc.EndPrinting();          // Finish printing

}


